/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */

/**
 * @api
 */
define([
    'jquery',
    'Magento_Ui/js/form/element/boolean',
    'underscore',
    'passwordStrengthIndicator'
], function ($, Element, _) {
    'use strict';

    return Element.extend({
        onElementRender: function () {


            $('#password').validation();
            $('#password-confirmation').validation();

            $("#password,#password-confirmation").blur(function () {
                $(this).validation('isValid');

            });

            $("#customer-email-fieldset .field.password").passwordStrengthIndicator(
                    {
                        passwordSelector: '#password',
                        formSelector: '#customer-email-fieldset'
                    }
            );
        },

        validate: function () {

            if (this.checked()) {

                var isValid = ($('#password').validation('isValid') && $('#password-confirmation').validation('isValid'));

                if (!isValid) {
                    this.error("error");
                    this.bubble('error', "error");
                    this.source.set('params.invalid', true);
                }

                return {
                    valid: isValid,
                    target: this
                };

            } else {
                return {
                    valid: true,
                    target: this
                };
            }


        },
        onUpdate: function () {
            this.bubble('update', this.hasChanged());

//            this.validate();
        },
    });
});
